<?php

/****************************************************************/
/*                                                              */
/*  Copyright: Xitara Websolution                               */
/*  Home: http://www.xitara.net                                 */
/*  E-Mail: info@xitara.net                                     */
/*                                                              */
/*  Software: RSC - Radio Statistic Class                       */
/*  Codename: Ichenu                                            */
/*                                                              */
/*  Startdate: 09.02.05                                         */
/*  Version: 0.1.7                                              */
/*                                                              */
/*  Autor: Manuel Burghammer                                    */
/*  Filename: radio.class.php                                   */
/*                                                              */
/*  Licence: GPL                                                */
/*  Description:                                                */
/*                                                              */
/****************************************************************/
/*                                                              */
/*  Dieses Copyright darf weder entfernt noch verndert werden  */
/*                                                              */
/****************************************************************/

/****************************************************************/
/*                                                              */
/*  changed by bytebanditkiller                                 */
/*  to use it with cacti, simplified only for icecast           */
/*                                                              */
/****************************************************************/

class radio{
			function init(){ 																												// Initialisierung und Erzeugung des Arrays mit den Werten
						$x_xml = $this->get_xml();
						$this->parse_xml($x_xml);
			}
			
			function get_xml(){ 																										// XML Status auslesen und alles unntige entfernen

						$sp = fsockopen($this->host, $this->port);

						$sp_data = "";																										// Variable inizialisieren

						if (!$sp)
										die('Error while connecting to Server.');
						else{																															// Authentifizieren am Server
										stream_set_blocking($sp, false);
										fputs($sp, "GET /admin/stats.xml HTTP/1.1\nUser-Agent: Mozilla\n");
										fputs($sp, "Host: " . $this->host . "\n");
										fputs($sp, "Authorization: Basic " . base64_encode("admin:" . $this->pass) . "\n\n");
		
										for($i = 0; $i < 30; $i++) {
													if(feof($sp))
															break;
													$sp_data .= fread($sp, 31337);
													usleep(500000);
										}
						}

						$sp_data = ereg_replace("^.*<icestats", "<icestats", $sp_data);
						
						fclose($sp);
						return $sp_data;
			}
			
			function set_host($host){ 																						// Host schreiben
						$this->host = $host;
			}
			
			function set_port($port){ 																						// Port schreiben
						$this->port = $port;
			}
			
			function set_pass($pass){ 																						// Passwort schreiben
						$this->pass = $pass;
			}
			
			function set_serv($serv){ 																						// Serverart schreiben
						$this->serv = $serv;
			}
			
			function parse_xml($x_xml){ 																					// XML Baum verarbeiten, Array mit Tags und Werten erzeugen
						$x_data_flag = FALSE;
						$x_parser = xml_parser_create();
						xml_parse_into_struct($x_parser, $x_xml, $x_vals, $x_index);
						xml_parser_free($x_parser);

						$this->x_vals = $x_vals;
						$this->x_index = $x_index;
		
		
						$x_count = 0;
						$xa_count = 0;

						$this->current_listeners = $x_vals[$x_index['CLIENTS'][0]]['value'];
			}
			
			function value($x_nodename){
						return $this->x_vals[$this->x_index[$x_nodename][0]]['value'];
			}
			
			function time_format($x_timeformat){
						$this->timeformat = $x_timeformat;
			}
}
?>